-- TileSheet.lua

Object = require("lib.classic.classic")

TileSheet = Object:extend()

function TileSheet:new(imagePath, tileSize, sheetWidth, sheetHeight, tileGutter, tileScale)

	self.texture = love.graphics.newImage(imagePath)
	self.tileSize = tileSize
	self.tileGutter = tileGutter or 0
	self.tileScale = tileScale or 1
	self.tileWidth = self.tileSize * self.tileScale
	self.tileHeight = self.tileSize * self.tileScale
	self.tileQuads = {}

	-- build the tile sheet quads:
	for y=0,(sheetHeight-1) do
		for x=0,(sheetWidth-1) do
			table.insert(self.tileQuads, love.graphics.newQuad((x*self.tileWidth)+(x*self.tileGutter), (y*self.tileHeight)+(y*self.tileGutter), self.tileWidth, self.tileHeight, self.texture:getWidth(), self.texture:getHeight()))
		end
	end
end

function TileSheet:getTexture() return self.texture end
function TileSheet:getTileWidth() return self.tileWidth end
function TileSheet:getTileHeight() return self.tileHeight end
function TileSheet:getTileQuad(tile) return self.tileQuads[tile] end
function TileSheet:getTileScale() return self.tileScale end