-- TileSheetEntity.lua

require("entity")
require("TileSheet")

TileSheetEntity = Entity:extend()

function TileSheetEntity:new(x, y, tileSheet, tile)

	TileSheetEntity.super.new(self, x, y)

	self.tileSheet = tileSheet
	self.tile = tile or 1
	self.width  = self.tileSheet:getTileWidth()
	self.height = self.tileSheet:getTileHeight()
	self.scale = self.tileSheet:getTileScale()
end

function TileSheetEntity:draw()

	love.graphics.draw(self.tileSheet:getTexture(), self.tileSheet:getTileQuad(self.tile), (self.x-1)*self.width, (self.y-1)*self.height, 0, self.scale, self.scale)

end