require 'Player'
require 'Box'
require 'TileSheetEntity'
require 'Wall'

-- main.lua

local tileSheet
local tileMap = {
	{16,14,14,14,14,14,17, 1, 1,16,14,14,14,14,14,17},
	{19, 0, 0, 0, 0, 0,18, 1, 1,19, 0, 0, 0, 0, 0,18},
	{19, 0, 0, 0, 0, 0,11,14,14,12, 0, 0, 0, 0, 0,18},
	{19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,18},
	{21, 9, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 9,22},
	{ 1, 1,19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,18, 1, 1},
	{ 1, 1,19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,18, 1, 1},
	{16,14,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,11,14,17},
	{19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,18},
	{19, 0, 0, 0, 0, 0, 6, 9, 9, 7, 0, 0, 0, 0, 0,18},
	{19, 0, 0, 0, 0, 0,18, 1, 1,19, 0, 0, 0, 0, 0,18},
	{21, 9, 9, 9, 9, 9,22, 1, 1,21, 9, 9, 9, 9, 9,22}
}

-- tables to contain collections of game entities
local objects, walls = {},{}

-- game entities
local player, box = {},{}

function love.load()

	player = Player(100, 100)
	box = Box(400, 150)

	table.insert(objects, player)
	table.insert(objects, box)

	tileSheet = TileSheet("assets/tiles/laboratory.png", 64, 5, 5, 1, 1)

	for y,v in ipairs(tileMap) do
		for x,tile in ipairs(v) do
			if tile > 0 then
				table.insert(walls, Wall((x-1)*tileSheet:getTileWidth(), (y-1)*tileSheet:getTileHeight(), tileSheet, tile))
			end
		end
	end
end

-- snip

-- drawing callback; called each frame after update()
function love.draw()

	love.graphics.setBackgroundColor(0, 64, 128)

	for i,v in ipairs(objects) do v:draw() end
	for i,v in ipairs(walls)   do v:draw() end

end